Opcode.Kind (Java SE 23 & JDK 23)
Description: declaration: module: java.base, package: java.lang.classfile, enum: Opcode, enum: Kind
Keywords: java.lang.classfile.Opcode.Kind class

# Enum Class Opcode.Kind

java.lang.Object
java.lang.Enum<Opcode.KindPREVIEW>
java.lang.classfile.Opcode.Kind

All Implemented Interfaces:
  `Serializable`, `Comparable<Opcode.KindPREVIEW>`, `Constable`

Enclosing class:
  `OpcodePREVIEW`

public static enum Opcode.Kind extends Enum<Opcode.KindPREVIEW>
`Kind` is a preview API of the Java platform.
Programs can only use `Kind` when preview features are enabled.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
Kinds of opcodes.

Since:
  22

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ARRAY_LOAD`
  Load from array
  `ARRAY_STORE`
  Store into array
  `BRANCH`
  Branch
  `CONSTANT`
  Constants
  `CONVERT`
  Type conversions
  `DISCONTINUED_JSR`
  Discontinued jump subroutine
  `DISCONTINUED_RET`
  Discontinued return from subroutine
  `FIELD_ACCESS`
  Access field
  `INCREMENT`
  Increment local variable
  `INVOKE`
  Invoke method or constructor
  `INVOKE_DYNAMIC`
  Invoke a dynamically-computed call site
  `LOAD`
  Load from local variable
  `LOOKUP_SWITCH`
  Access jump table by key match and jump
  `MONITOR`
  Monitor
  `NEW_MULTI_ARRAY`
  Create new multidimensional array
  `NEW_OBJECT`
  Create new object
  `NEW_PRIMITIVE_ARRAY`
  Create new array
  `NEW_REF_ARRAY`
  Create new reference array
  `NOP`
  Do nothing
  `OPERATOR`
  Operators
  `RETURN`
  Return from method
  `STACK`
  Stack operations
  `STORE`
  Store into local variable
  `TABLE_SWITCH`
  Access jump table by index and jump
  `THROW_EXCEPTION`
  Throw exception or error
  `TYPE_CHECK`
  Check whether object is of given type

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Opcode.KindPREVIEW`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Opcode.KindPREVIEW[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### LOAD

    public static final Opcode.KindPREVIEW LOAD
    Load from local variable
    See Also:
      - `Opcode.ILOAD`PREVIEW
      - `Opcode.LLOAD`PREVIEW
      - `Opcode.FLOAD`PREVIEW
      - `Opcode.DLOAD`PREVIEW
      - `Opcode.ALOAD`PREVIEW
      - `Opcode.ILOAD_0`PREVIEW
      - `Opcode.ILOAD_1`PREVIEW
      - `Opcode.ILOAD_2`PREVIEW
      - `Opcode.ILOAD_3`PREVIEW
      - `Opcode.LLOAD_0`PREVIEW
      - `Opcode.LLOAD_1`PREVIEW
      - `Opcode.LLOAD_2`PREVIEW
      - `Opcode.LLOAD_3`PREVIEW
      - `Opcode.FLOAD_0`PREVIEW
      - `Opcode.FLOAD_1`PREVIEW
      - `Opcode.FLOAD_2`PREVIEW
      - `Opcode.FLOAD_3`PREVIEW
      - `Opcode.DLOAD_0`PREVIEW
      - `Opcode.DLOAD_1`PREVIEW
      - `Opcode.DLOAD_2`PREVIEW
      - `Opcode.DLOAD_3`PREVIEW
      - `Opcode.ALOAD_0`PREVIEW
      - `Opcode.ALOAD_1`PREVIEW
      - `Opcode.ALOAD_2`PREVIEW
      - `Opcode.ALOAD_3`PREVIEW
      - `Opcode.ILOAD_W`PREVIEW
      - `Opcode.LLOAD_W`PREVIEW
      - `Opcode.FLOAD_W`PREVIEW
      - `Opcode.DLOAD_W`PREVIEW
      - `Opcode.ALOAD_W`PREVIEW

  - ### STORE

    public static final Opcode.KindPREVIEW STORE
    Store into local variable
    See Also:
      - `Opcode.ISTORE`PREVIEW
      - `Opcode.LSTORE`PREVIEW
      - `Opcode.FSTORE`PREVIEW
      - `Opcode.DSTORE`PREVIEW
      - `Opcode.ASTORE`PREVIEW
      - `Opcode.ISTORE_0`PREVIEW
      - `Opcode.ISTORE_1`PREVIEW
      - `Opcode.ISTORE_2`PREVIEW
      - `Opcode.ISTORE_3`PREVIEW
      - `Opcode.LSTORE_0`PREVIEW
      - `Opcode.LSTORE_1`PREVIEW
      - `Opcode.LSTORE_2`PREVIEW
      - `Opcode.LSTORE_3`PREVIEW
      - `Opcode.FSTORE_0`PREVIEW
      - `Opcode.FSTORE_1`PREVIEW
      - `Opcode.FSTORE_2`PREVIEW
      - `Opcode.FSTORE_3`PREVIEW
      - `Opcode.DSTORE_0`PREVIEW
      - `Opcode.DSTORE_1`PREVIEW
      - `Opcode.DSTORE_2`PREVIEW
      - `Opcode.DSTORE_3`PREVIEW
      - `Opcode.ASTORE_0`PREVIEW
      - `Opcode.ASTORE_1`PREVIEW
      - `Opcode.ASTORE_2`PREVIEW
      - `Opcode.ASTORE_3`PREVIEW
      - `Opcode.ISTORE_W`PREVIEW
      - `Opcode.LSTORE_W`PREVIEW
      - `Opcode.FSTORE_W`PREVIEW
      - `Opcode.DSTORE_W`PREVIEW
      - `Opcode.ASTORE_W`PREVIEW

  - ### INCREMENT

    public static final Opcode.KindPREVIEW INCREMENT
    Increment local variable
    See Also:
      - `Opcode.IINC`PREVIEW
      - `Opcode.IINC_W`PREVIEW

  - ### BRANCH

    public static final Opcode.KindPREVIEW BRANCH
    Branch
    See Also:
      - `Opcode.IFEQ`PREVIEW
      - `Opcode.IFNE`PREVIEW
      - `Opcode.IFLT`PREVIEW
      - `Opcode.IFGE`PREVIEW
      - `Opcode.IFGT`PREVIEW
      - `Opcode.IFLE`PREVIEW
      - `Opcode.IF_ICMPEQ`PREVIEW
      - `Opcode.IF_ICMPNE`PREVIEW
      - `Opcode.IF_ICMPLT`PREVIEW
      - `Opcode.IF_ICMPGE`PREVIEW
      - `Opcode.IF_ICMPGT`PREVIEW
      - `Opcode.IF_ICMPLE`PREVIEW
      - `Opcode.IF_ACMPEQ`PREVIEW
      - `Opcode.IF_ACMPNE`PREVIEW
      - `Opcode.GOTO`PREVIEW
      - `Opcode.IFNULL`PREVIEW
      - `Opcode.IFNONNULL`PREVIEW
      - `Opcode.GOTO_W`PREVIEW

  - ### LOOKUP_SWITCH

    public static final Opcode.KindPREVIEW LOOKUP_SWITCH
    Access jump table by key match and jump
    See Also:
      - `Opcode.LOOKUPSWITCH`PREVIEW

  - ### TABLE_SWITCH

    public static final Opcode.KindPREVIEW TABLE_SWITCH
    Access jump table by index and jump
    See Also:
      - `Opcode.TABLESWITCH`PREVIEW

  - ### RETURN

    public static final Opcode.KindPREVIEW RETURN
    Return from method
    See Also:
      - `Opcode.IRETURN`PREVIEW
      - `Opcode.LRETURN`PREVIEW
      - `Opcode.FRETURN`PREVIEW
      - `Opcode.DRETURN`PREVIEW
      - `Opcode.ARETURN`PREVIEW
      - `Opcode.RETURN`PREVIEW

  - ### THROW_EXCEPTION

    public static final Opcode.KindPREVIEW THROW_EXCEPTION
    Throw exception or error
    See Also:
      - `Opcode.ATHROW`PREVIEW

  - ### FIELD_ACCESS

    public static final Opcode.KindPREVIEW FIELD_ACCESS
    Access field
    See Also:
      - `Opcode.GETSTATIC`PREVIEW
      - `Opcode.PUTSTATIC`PREVIEW
      - `Opcode.GETFIELD`PREVIEW
      - `Opcode.PUTFIELD`PREVIEW

  - ### INVOKE

    public static final Opcode.KindPREVIEW INVOKE
    Invoke method or constructor
    See Also:
      - `Opcode.INVOKEVIRTUAL`PREVIEW
      - `Opcode.INVOKESPECIAL`PREVIEW
      - `Opcode.INVOKESTATIC`PREVIEW
      - `Opcode.INVOKEINTERFACE`PREVIEW

  - ### INVOKE_DYNAMIC

    public static final Opcode.KindPREVIEW INVOKE_DYNAMIC
    Invoke a dynamically-computed call site
    See Also:
      - `Opcode.INVOKEDYNAMIC`PREVIEW

  - ### NEW_OBJECT

    public static final Opcode.KindPREVIEW NEW_OBJECT
    Create new object
    See Also:
      - `Opcode.NEW`PREVIEW

  - ### NEW_PRIMITIVE_ARRAY

    public static final Opcode.KindPREVIEW NEW_PRIMITIVE_ARRAY
    Create new array
    See Also:
      - `Opcode.NEWARRAY`PREVIEW

  - ### NEW_REF_ARRAY

    public static final Opcode.KindPREVIEW NEW_REF_ARRAY
    Create new reference array
    See Also:
      - `Opcode.ANEWARRAY`PREVIEW

  - ### NEW_MULTI_ARRAY

    public static final Opcode.KindPREVIEW NEW_MULTI_ARRAY
    Create new multidimensional array
    See Also:
      - `Opcode.MULTIANEWARRAY`PREVIEW

  - ### TYPE_CHECK

    public static final Opcode.KindPREVIEW TYPE_CHECK
    Check whether object is of given type
    See Also:
      - `Opcode.CHECKCAST`PREVIEW
      - `Opcode.INSTANCEOF`PREVIEW

  - ### ARRAY_LOAD

    public static final Opcode.KindPREVIEW ARRAY_LOAD
    Load from array
    See Also:
      - `Opcode.IALOAD`PREVIEW
      - `Opcode.LALOAD`PREVIEW
      - `Opcode.FALOAD`PREVIEW
      - `Opcode.DALOAD`PREVIEW
      - `Opcode.AALOAD`PREVIEW
      - `Opcode.BALOAD`PREVIEW
      - `Opcode.CALOAD`PREVIEW
      - `Opcode.SALOAD`PREVIEW

  - ### ARRAY_STORE

    public static final Opcode.KindPREVIEW ARRAY_STORE
    Store into array
    See Also:
      - `Opcode.IASTORE`PREVIEW
      - `Opcode.LASTORE`PREVIEW
      - `Opcode.FASTORE`PREVIEW
      - `Opcode.DASTORE`PREVIEW
      - `Opcode.AASTORE`PREVIEW
      - `Opcode.BASTORE`PREVIEW
      - `Opcode.CASTORE`PREVIEW
      - `Opcode.SASTORE`PREVIEW

  - ### STACK

    public static final Opcode.KindPREVIEW STACK
    Stack operations
    See Also:
      - `Opcode.POP`PREVIEW
      - `Opcode.POP2`PREVIEW
      - `Opcode.DUP`PREVIEW
      - `Opcode.DUP_X1`PREVIEW
      - `Opcode.DUP_X2`PREVIEW
      - `Opcode.DUP2`PREVIEW
      - `Opcode.DUP2_X1`PREVIEW
      - `Opcode.DUP2_X2`PREVIEW
      - `Opcode.SWAP`PREVIEW

  - ### CONVERT

    public static final Opcode.KindPREVIEW CONVERT
    Type conversions
    See Also:
      - `Opcode.I2L`PREVIEW
      - `Opcode.I2F`PREVIEW
      - `Opcode.I2D`PREVIEW
      - `Opcode.L2I`PREVIEW
      - `Opcode.L2F`PREVIEW
      - `Opcode.L2D`PREVIEW
      - `Opcode.F2I`PREVIEW
      - `Opcode.F2L`PREVIEW
      - `Opcode.F2D`PREVIEW
      - `Opcode.D2I`PREVIEW
      - `Opcode.D2L`PREVIEW
      - `Opcode.D2F`PREVIEW
      - `Opcode.I2B`PREVIEW
      - `Opcode.I2C`PREVIEW
      - `Opcode.I2S`PREVIEW

  - ### OPERATOR

    public static final Opcode.KindPREVIEW OPERATOR
    Operators
    See Also:
      - `Opcode.IADD`PREVIEW
      - `Opcode.LADD`PREVIEW
      - `Opcode.FADD`PREVIEW
      - `Opcode.DADD`PREVIEW
      - `Opcode.ISUB`PREVIEW
      - `Opcode.LSUB`PREVIEW
      - `Opcode.FSUB`PREVIEW
      - `Opcode.DSUB`PREVIEW
      - `Opcode.IMUL`PREVIEW
      - `Opcode.LMUL`PREVIEW
      - `Opcode.FMUL`PREVIEW
      - `Opcode.DMUL`PREVIEW
      - `Opcode.IDIV`PREVIEW
      - `Opcode.LDIV`PREVIEW
      - `Opcode.FDIV`PREVIEW
      - `Opcode.DDIV`PREVIEW
      - `Opcode.IREM`PREVIEW
      - `Opcode.LREM`PREVIEW
      - `Opcode.FREM`PREVIEW
      - `Opcode.DREM`PREVIEW
      - `Opcode.INEG`PREVIEW
      - `Opcode.LNEG`PREVIEW
      - `Opcode.FNEG`PREVIEW
      - `Opcode.DNEG`PREVIEW
      - `Opcode.ISHL`PREVIEW
      - `Opcode.LSHL`PREVIEW
      - `Opcode.ISHR`PREVIEW
      - `Opcode.LSHR`PREVIEW
      - `Opcode.IUSHR`PREVIEW
      - `Opcode.LUSHR`PREVIEW
      - `Opcode.IAND`PREVIEW
      - `Opcode.LAND`PREVIEW
      - `Opcode.IOR`PREVIEW
      - `Opcode.LOR`PREVIEW
      - `Opcode.IXOR`PREVIEW
      - `Opcode.LXOR`PREVIEW
      - `Opcode.LCMP`PREVIEW
      - `Opcode.FCMPL`PREVIEW
      - `Opcode.FCMPG`PREVIEW
      - `Opcode.DCMPL`PREVIEW
      - `Opcode.DCMPG`PREVIEW
      - `Opcode.ARRAYLENGTH`PREVIEW

  - ### CONSTANT

    public static final Opcode.KindPREVIEW CONSTANT
    Constants
    See Also:
      - `Opcode.ACONST_NULL`PREVIEW
      - `Opcode.ICONST_M1`PREVIEW
      - `Opcode.ICONST_0`PREVIEW
      - `Opcode.ICONST_1`PREVIEW
      - `Opcode.ICONST_2`PREVIEW
      - `Opcode.ICONST_3`PREVIEW
      - `Opcode.ICONST_4`PREVIEW
      - `Opcode.ICONST_5`PREVIEW
      - `Opcode.LCONST_0`PREVIEW
      - `Opcode.LCONST_1`PREVIEW
      - `Opcode.FCONST_0`PREVIEW
      - `Opcode.FCONST_1`PREVIEW
      - `Opcode.FCONST_2`PREVIEW
      - `Opcode.DCONST_0`PREVIEW
      - `Opcode.DCONST_1`PREVIEW
      - `Opcode.BIPUSH`PREVIEW
      - `Opcode.SIPUSH`PREVIEW
      - `Opcode.LDC`PREVIEW
      - `Opcode.LDC_W`PREVIEW
      - `Opcode.LDC2_W`PREVIEW

  - ### MONITOR

    public static final Opcode.KindPREVIEW MONITOR
    Monitor
    See Also:
      - `Opcode.MONITORENTER`PREVIEW
      - `Opcode.MONITOREXIT`PREVIEW

  - ### NOP

    public static final Opcode.KindPREVIEW NOP
    Do nothing
    See Also:
      - `Opcode.NOP`PREVIEW

  - ### DISCONTINUED_JSR

    public static final Opcode.KindPREVIEW DISCONTINUED_JSR
    Discontinued jump subroutine
    See Also:
      - `Opcode.JSR`PREVIEW
      - `Opcode.JSR_W`PREVIEW
      - `DiscontinuedInstruction`PREVIEW

  - ### DISCONTINUED_RET

    public static final Opcode.KindPREVIEW DISCONTINUED_RET
    Discontinued return from subroutine
    See Also:
      - `Opcode.RET`PREVIEW
      - `Opcode.RET_W`PREVIEW
      - `DiscontinuedInstruction`PREVIEW

- ## Method Details

  - ### values

    public static Opcode.KindPREVIEW[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Opcode.KindPREVIEW valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null